chiark / gitweb /
Avoid use of "my $_", which is not portable
[dgit.git] / tests / tests / drs-push-rejects
index 7f088103adbf621c36e5dfab9e577063c7e69c49..e80620daafe11233289f6a81727688d193ae6923 100755 (executable)
@@ -10,37 +10,16 @@ t-worktree drs
 
 cd $p
 
-reporefs () {
-       (set -e
-       if test -d $tmp/git/$p.git; then
-               cd $tmp/git/$p.git
-               git show-ref
-       fi)
-}
-
 mustfail () {
-       local wantmsg="$1"; shift
-       reporefs >$tmp/show-refs.pre-push
-       set +e
-       git push origin "$@" 2>&1 |tee $tmp/mustfail.txt
-       ps="${PIPESTATUS[*]}"
-       set -e
-       case $ps in
-       "0 0")  fail "push unexpectedly succeeded (instead of: $wantmsg)" ;;
-       *" 0")  ;;
-       *)      fail "tee failed"  ;;
-       esac
-       if ! fgrep "$wantmsg" $tmp/mustfail.txt >/dev/null; then
-               fail "error message not found"
-       fi
-       reporefs >$tmp/show-refs.post-push
-       diff $tmp/show-refs.{pre,post}-push
+       local mpat="$1"; shift
+       t-expect-push-fail "$mpat" \
+       git push origin "$@"
 }
 
 mustsucceed () {
-       reporefs >$tmp/show-refs.pre-push
+       t-reporefs pre-push
        git push origin "$@"
-       reporefs >$tmp/show-refs.post-push
+       t-reporefs post-push
        if diff $tmp/show-refs.{pre,post}-push >$tmp/show-refs.diff; then
                fail "no refs updated"
        fi
@@ -71,6 +50,39 @@ tag_signer='-a'
 mktag
 mustfail 'missing signature' $push_spec
 
+git cat-file tag $tag_name >goodtag
+
+for h in object type tag; do
+  for how in missing dupe; do
+
+    case $how in
+    missing) perl -pe 's/^tag /wombat$&/ if 1..m/^$/'  <goodtag >badtag ;;
+    dupe)   perl -pe 'print if 1..m/^$/ and m/^'$h' /' <goodtag >badtag ;;
+    esac
+
+    rm -f badtag.asc
+    gpg --detach-sign --armor -u Senatus badtag
+    cat badtag.asc >>badtag
+
+    set +e
+    LC_MESSAGES=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
+    rc=$?
+    set -e
+
+    if [ $rc = 128 ] && grep 'fatal: corrupt tag' badtag.err; then
+      continue
+    elif [ $rc != 0 ]; then
+      cat badtag.err
+      fail "could not make tag"
+    fi
+
+    read <badtag.hash badtag
+    git update-ref refs/tags/$tag_name $badtag
+
+    mustfail 'multiple headers '$h' in signed tag object' $push_spec
+  done
+done
+
 prep unstable sid
 tag_message='something'
 mktag
@@ -91,6 +103,17 @@ mustfail 'pushing unexpected ref' $push_spec HEAD:refs/wombat
 mustfail 'pushing multiple heads' $push_spec HEAD:refs/dgit/wombat
 mustfail 'pushing multiple tags' $push_spec HEAD:refs/tags/debian/wombat
 
+prep unstable sid
+mktag
+echo woody >$tmp/suites
+mustfail 'unknown suite' $push_spec
+cp $root/tests/suites $tmp/.
+
+# fixme:
+#    or reject "command string not understood";
+#    reject "unknown method" unless $mainfunc;
+
+
 prep unstable sid
 mktag
 cp $tmp/dm.gpg $tmp/dd.gpg
@@ -115,8 +138,13 @@ prep unstable sid
 mktag
 mustsucceed $push_spec # succeeds
 
+mktag
+mustfail 'push is missing head ref update' $push_spec
+
+git commit --allow-empty -m 'Dummy update'
 mktag
 mustfail 'not replacing previously-pushed version' $push_spec
+git reset --hard HEAD~
 
 prep_dm_mangle () {
        prep unstable sid